#! /bin/csh
#-------------------------------------------------------
# amanda alexander 95/8/9
set echo

switch ($#argv)
case 0:
        echo ""
        echo "usage: dec.csh  num_lines"
        echo ""
        echo "number of lines to delete from the top"
        exit
endsw

# find files to give SCCS headers to

# find does not follow symbolic links - good
set filenames = `find . \( -name "*.c" -o -name "*.h" -o -name "*.C" \) -print` 

foreach fn ($filenames)
# if no SCCS, then add it
        if (`grep \-l "SCCS" $fn` ==  $fn) then
                echo $fn
                decapitate -i $fn -o _tmp_ -n $1
                mv _tmp_ $fn
        endif
end
