/* SCCS  %W%---%E%--%U% */
//
//	nsl_num_data.h
//

class nsl_num_data : public nsl_data_layer
{
protected:
	num_type v; 
public:
		nsl_num_data(const num_type=0,int = 1);
		nsl_num_data(const char*,const num_type=0,int=0,int=1);
		nsl_num_data(const nsl_num_data&,int = 1);

		~nsl_num_data();

	int	init_num_data();

// get value
	num_type get_data() 	const { return v; }
	num_type get_value() 	const { return v; }
	num_type& elem() { return v; } 	

// set value
	num_type	set_value(const int);
	num_type	set_value(const float);
	num_type	set_value(const double);

// assignment
	num_type 	operator=(const nsl_num_data&);
	num_type 	operator=(const double);
	num_type 	operator=(const float);
	num_type 	operator=(const int);

// print
	virtual int	print(ostream&) const;
	int	print_num_data(ostream&) const;
	virtual int	print_status(ostream&) const;
	int	print_num_data_status(ostream&) const;

	int 	reset_num_data(nsl_buffer* = 0);
	virtual int 	reset(nsl_buffer* = 0);

	int 	write_num_data(nsl_buffer&);
	virtual int 	write(nsl_buffer&);
	int 	read_num_data(nsl_buffer&);
	virtual int 	read(nsl_buffer&);
};
