/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_max_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_2<NslNumType,NslTypeId>_max_library.h                    */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);

*/
template<class NslNumType, int NslTypeId>
num_type NSLmax(const nsl_num_2<NslNumType,NslTypeId>& a) 
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();

	nsl_num_data c;
	c = 0;

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > c)
			c = a[i][j];
	return c.get_data();
}

// if a > b then a else b

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != b.get_imax() || a.get_jmax() != b.get_jmax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("jmax2: ",b.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b[i][j])
			c[i][j] = a[i][j];
		else
			c[i][j] = b[i][j];
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j];
		else
			c[i][j] = b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>& a,const float b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j];
		else
			c[i][j] = b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>& a,const double b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j];
		else
			c[i][j] = b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmax(const nsl_num_2<NslNumType,NslTypeId>& a,const int b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j];
		else
			c[i][j] = b;
	return c;
}
