/* SCCS  @(#)nsl_num_4_conv_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_4_conv_library.h
//
/*
extern	nsl_num_4 	operator*(const nsl_num_4&,const nsl_num_4&);
extern	nsl_num_4 	operator*(const nsl_vector&,const nsl_num_4&);
extern	nsl_num_4 	operator*(const nsl_num_4&,const nsl_vector&);
extern	nsl_num_4 	operator*(const nsl_num_4&,const nsl_data&);
extern	nsl_num_4 	operator*(const nsl_data&,const nsl_num_4&);
*/
/*
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator*(const num_type,const nsl_num_4<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator*(const nsl_num_4<NslNumType,NslTypeId>&,const num_type);
*/
/*
extern nsl_num_4 NSLconv_zero(const nsl_num_4&,const num_type);
extern nsl_num_4 NSLconv_zero(const num_type,const nsl_num_4&);
extern nsl_num_4 NSLconv_zero(const nsl_num_4&,const nsl_data&);
extern nsl_num_4 NSLconv_zero(const nsl_data&,const nsl_num_4&);
extern nsl_num_4 NSLconv_zero(const nsl_num_4&,const nsl_vector&);
extern nsl_num_4 NSLconv_zero(const nsl_vector&,const nsl_num_4&);
extern nsl_num_4 NSLconv_zero(const nsl_num_4&,const nsl_num_4&);
extern nsl_num_4 NSLconv_wrap(const nsl_num_4&,const nsl_num_4&);
extern nsl_num_4 NSLconv_copy(const nsl_num_4&,const nsl_num_4&);
*/
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator*(const nsl_num_4<NslNumType,NslTypeId>& a,const num_type b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator*\n";
        cout << "// (matrix) " << a.get_name() << " * (num_type) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator*(const num_type a, const nsl_num_4<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator*\n";
        cout << "// (num_type) " << a << " * (num_4) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
		for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a * b[i][j][k][l];

	return c;
}