/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_comp_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_1<NslNumType,NslTypeId>_comp_library.h
//
/*
extern	int 		operator>(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	int 		operator<(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	int 		operator>(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator<(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator>(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator<(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator>(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator<(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);

extern	int 		operator>=(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	int 		operator<=(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	int 		operator>=(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator<=(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator>=(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator<=(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator>=(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator<=(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);

extern	int 		operator==(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	int 		operator!=(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	int 		operator==(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator!=(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator==(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator!=(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator==(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	int 		operator!=(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
*/
// vector convolution

// comparator

template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_1<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] > b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_1<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] > b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_1<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] > b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_1<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_1<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_1<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a > b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a > b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a > b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a < b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a < b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a < b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_1<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] > b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_1<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a > b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a < b[i])
			return 1;
	return 0;
}

// >=, <=

template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_1<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] >= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_1<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] >= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_1<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] >= b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_1<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_1<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_1<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a >= b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a >= b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a >= b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const float a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a <= b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const double a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a <= b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const int a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a <= b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_1<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] >= b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_1<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a >= b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a <= b[i])
			return 1;
	return 0;
}

// ==, !=

template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_1<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] == b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_1<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] == b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_1<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] == b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_1<NslNumType,NslTypeId>& a,const  float b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_1<NslNumType,NslTypeId>& a,const  double b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_1<NslNumType,NslTypeId>& a,const  int b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const float a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a == b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const double a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a == b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const int a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a == b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a != b[i])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator!=(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a != b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a != b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_1<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] == b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_1<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a == b[i])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a != b[i])
			return 1;
	return 0;
}

