/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_min_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_1<NslNumType,NslTypeId>_min_library.h                    */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_1<NslNumType,NslTypeId> NSLmin(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLmin(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLmin(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
*/

template<class NslNumType, int NslTypeId>
NslNumType NSLmin(const nsl_num_1<NslNumType,NslTypeId>& a) 
{
	int s1 = a.get_imax();

	nsl_num_data c;
	c = 0;

	for (int i = 0; i < s1; i++)
		if (a[i] < c)
			c = a[i];

	return c.get_data();
}

// if a < b then a else b

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmin(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != b.get_imax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] < b[i])
			c[i] = a[i];
		else
			c[i] = b[i];
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmin(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] < b)
			c[i] = a[i];
		else
			c[i] = b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmin(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType b)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] < b)
			c[i] = a[i];
		else
			c[i] = b;
	return c;
}
