/* SCCS  %W%---%E%--%U% */
//
// 	xnsl_area_level_graph.h
//

class xnsl_area_level_graph : public xnsl_graph
{
public:
	xnsl_area_level_graph(xnsl_display_canvas* = 0);
	virtual ~xnsl_area_level_graph();

    virtual xnsl_widget *make_widget();

	virtual int clear();

    virtual int display();
    virtual int display_area_level_graph(xnsl_widget* = 0,int=0,int=0,int=10,int=10,
		num_type = 0.0, num_type = 1.0,int = 0, int = 0, int = 0);
    int display_area_level_graph_val(xnsl_widget* = 0,int=0,int=0,int=10,int=10,
		num_type = 0.0, num_type = 0.0, num_type = 1.0,int=0,int=0);

	virtual int read_from_database();
	virtual int write_to_database();
	virtual int input(int = 0,int = 0, int = 0);
	virtual int output(int = 0,int = 0);
	virtual int print(ostream&) const;
};
/*
template<class NslType>
xnsl_area_level_graph<NslType>::xnsl_area_level_graph(xnsl_display_canvas* win) : 
	xnsl_graph<NslType>(win) 
{
        set_type("area_level_graph");
}
template<class NslType>
xnsl_area_level_graph<NslType>::~xnsl_area_level_graph()  
{
}

template<class NslType>
xnsl_widget * xnsl_area_level_graph<NslType>::make_widget()
{
	cmd_error("xnsl_area_level_graph: CANNOT create widget");
        return 0;
}

template<class NslType>
int xnsl_area_level_graph<NslType>::clear()
{
 	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::display()
{
//      display_area_level_graph(_widget,_wx0,_wy0,_wxs,_wys,_wymin,_wymax);
         
//      xflush();
         
      	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::display_area_level_graph(xnsl_widget*,
	int,int,int,int,num_type, num_type,int,int,int)
{
 	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::display_area_level_graph_val(xnsl_widget* widget,
	int wx0,int wy0,int wxs,int wys,
	num_type val,num_type vmin, num_type vmax,int ni,int nj) 
{
        int wxc,wyc,i0,j0,ic,jc;
        num_type s;
		int pos = 0;

//	if (val == 0) 
	    clear_area(widget,wx0+1,wy0+1,wxs-1,wys-1,pos);  // always clear first
//        else
        {
            if (vmin > 0.0)
                vmin = 0.0;
            if (vmax < 0.0)
                vmax = 0.0;
            if (vmin == 0.0 && vmax == 0.0)
                vmax = 1.0;

            if ((val>=vmax && vmax > 0.0) || (val<=vmin && vmin < 0.0))
            {
                wxc = wxs;
                wyc = wys;
            }
            else
            {
                s = 0.0;
                if (val > 0.0 && vmax > 0.0)
                    s = val/vmax;
                else if (val < 0.0 && vmin < 0.0)
                    s = val/vmin;

                wxc = (int) nsl_rint(s*wxs);
                wyc = (int) nsl_rint(s*wys);
            }
            ic = (wxs - wxc)/2;	  // x length to be taken out from half area
            jc = (wys - wyc)/2;	  // y length to be taken out from half area
            i0 = ic + wx0;	  // x starting point for new graph
            j0 = jc + wy0;	  // y starting point for new graph
	    wxc = wx0 + wxs - i0 - ic; // make sure x area is symmetric
	    wyc = wy0 + wys - j0 - jc; // make sure y are is symmetric
            if (wxc-1 > 0 && wyc-1 > 0) {
		 if (val <= 0.0)
			pos = -1;
//		 fill_rectangle(widget,i0+1,j0,wxc-1,wyc-1,ni,nj,pos); 
		 fill_rectangle(widget,i0,j0,wxc,wyc,ni,nj,pos); //tk draw: 1, xdraw: 0
	    }
//          
//            {
//                if (wxc-3 > 0 && wyc-3 > 0)
//					clear_area(widget,i0+2,j0+1,wxc-3,wyc-3); 
//            }
//
        }

	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::read_from_database()
{
	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::write_to_database()
{
	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::input(int,int,int)
{
	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::output(int,int)
{
	return 1;
}
template<class NslType>
int xnsl_area_level_graph<NslType>::print(ostream&) const
{
	return 1;
}

*/