/* SCCS  @(#)nsl_input_include.h	1.2---97/03/05--19:45:32 */
//
//	nsl_input_include.h
//

 class nsl_input_layer;
 class nsl_input_data;
 class nsl_input_vector;
 class nsl_input_matrix;
 class nsl_input_3d;

 class nsl_stim;
 class nsl_stim_data;
 class nsl_stim_vector;
 class nsl_stim_matrix;
 class nsl_stim_3d;
 class nsl_block_stim_data;
 class nsl_block_stim_vector;
 class nsl_block_stim_matrix;
 class nsl_block_stim_3d;
 class nsl_icon_stim_data;
 class nsl_icon_stim_vector;
 class nsl_icon_stim_matrix;

 class nsl_stim_type_data;
 class nsl_spec_type_data;

 class nsl_time_interval;

enum spec_type_enum { NSL_CORNER=0, NSL_CENTER=1 };
enum stim_type_enum { NSL_BLOCK=0, NSL_ICON=1 };
 
# include "input_stim_incl/nsl_input_layer.h"
# include "input_stim_incl/nsl_input_data.h"
# include "input_stim_incl/nsl_input_vector.h"
# include "input_stim_incl/nsl_input_matrix.h"
# include "input_stim_incl/nsl_input_3d.h"

# include "input_stim_incl/nsl_stim.h"
# include "input_stim_incl/nsl_stim_data.h"
# include "input_stim_incl/nsl_stim_vector.h"
# include "input_stim_incl/nsl_stim_matrix.h"
# include "input_stim_incl/nsl_stim_3d.h"
# include "input_stim_incl/nsl_block_stim_data.h"
# include "input_stim_incl/nsl_block_stim_vector.h"
# include "input_stim_incl/nsl_block_stim_matrix.h"
# include "input_stim_incl/nsl_block_stim_3d.h"
# include "input_stim_incl/nsl_icon_stim_data.h"
# include "input_stim_incl/nsl_icon_stim_vector.h"
# include "input_stim_incl/nsl_icon_stim_matrix.h"

# include "input_stim_incl/nsl_spec_type_data.h"
# include "input_stim_incl/nsl_stim_type_data.h"

# include "input_stim_incl/nsl_time_interval.h"

