/* SCCS  @(#)nsl_buffer_stream_library.h	1.1---95/08/13--23:38:36 */
//
// nsl_buffer_stream_library.h
//

extern 	nsl_buffer& operator>>(nsl_buffer&,char&);
extern 	nsl_buffer& operator<<(nsl_buffer&,char);

extern 	nsl_buffer& operator>>(nsl_buffer&,char*); // str
extern 	nsl_buffer& operator<<(nsl_buffer&,const char*); // str

extern 	nsl_buffer& operator>>(nsl_buffer&,int&);
extern 	nsl_buffer& operator<<(nsl_buffer&,int);

extern 	nsl_buffer& operator>>(nsl_buffer&,float&);
extern 	nsl_buffer& operator<<(nsl_buffer&,float);

extern 	nsl_buffer& operator>>(nsl_buffer&,double&);
extern 	nsl_buffer& operator<<(nsl_buffer&,double);

extern nsl_buffer& operator>>(nsl_buffer&,nsl_layer&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_data_layer&);
//extern nsl_buffer& operator>>(nsl_buffer&,nsl_int_data&);
//extern nsl_buffer& operator>>(nsl_buffer&,nsl_num_data&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_str_data&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_ptr_data&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_vector_layer&);
//extern nsl_buffer& operator>>(nsl_buffer&,nsl_int_vector&);
//extern nsl_buffer& operator>>(nsl_buffer&,nsl_num_vector&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_str_vector&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_ptr_vector&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_matrix_layer&);
//extern nsl_buffer& operator>>(nsl_buffer&,nsl_int_matrix&);
//extern nsl_buffer& operator>>(nsl_buffer&,nsl_num_matrix&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_str_matrix&);
extern nsl_buffer& operator>>(nsl_buffer&,nsl_ptr_matrix&);

extern nsl_buffer& operator<<(nsl_buffer&,nsl_layer&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_data_layer&);
//extern nsl_buffer& operator<<(nsl_buffer&,nsl_int_data&);
//extern nsl_buffer& operator<<(nsl_buffer&,nsl_num_data&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_str_data&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_ptr_data&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_vector_layer&);
//extern nsl_buffer& operator<<(nsl_buffer&,nsl_int_vector&);
//extern nsl_buffer& operator<<(nsl_buffer&,nsl_num_vector&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_str_vector&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_ptr_vector&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_matrix_layer&);
//extern nsl_buffer& operator<<(nsl_buffer&,nsl_int_matrix&);
//extern nsl_buffer& operator<<(nsl_buffer&,nsl_num_matrix&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_str_matrix&);
extern nsl_buffer& operator<<(nsl_buffer&,nsl_ptr_matrix&);

template<class NslNumType, int NslTypeId>
nsl_buffer& operator>>(nsl_buffer& buf,nsl_num_0<NslNumType,NslTypeId>& layer)
{
	layer.read_num_data(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_buffer& operator<<(nsl_buffer& buf,nsl_num_0<NslNumType,NslTypeId>& layer)
{
	layer.write_num_data(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_buffer& operator>>(nsl_buffer& buf,nsl_num_1<NslNumType,NslTypeId>& layer)
{
	layer.read_num_vector(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_buffer& operator<<(nsl_buffer& buf,nsl_num_1<NslNumType,NslTypeId>& layer)
{
	layer.write_num_vector(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_buffer& operator>>(nsl_buffer& buf,nsl_num_2<NslNumType,NslTypeId>& layer)
{
	layer.read_num_matrix(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_buffer& operator<<(nsl_buffer& buf,nsl_num_2<NslNumType,NslTypeId>& layer)
{
	layer.write_num_matrix(buf);

	return buf;
}

// iostream

extern 	nsl_buffer& operator<<(nsl_buffer&,istream&);
extern 	nsl_buffer& operator>>(nsl_buffer&,ostream&);
extern 	nsl_buffer& operator<<(nsl_buffer&,fstream&);
extern 	nsl_buffer& operator>>(nsl_buffer&,fstream&);

extern istream& operator>>(istream&,nsl_buffer&);
extern ostream& operator<<(ostream&,nsl_buffer&);
extern fstream& operator>>(fstream&,nsl_buffer&);
extern fstream& operator<<(fstream&,nsl_buffer&);
