/* SCCS  @(#)nsl_num_0<NslNumType,NslTypeId>_add_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_0<NslNumType,NslTypeId>_add_library.h
//
/*AW98
extern	nsl_num_0<NslNumType,NslTypeId> 	operator+(const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_0<NslNumType,NslTypeId> 	operator+(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern 	nsl_num_0<NslNumType,NslTypeId> 	operator+(const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType);
*/
/*
extern 	nsl_num_0<NslNumType,NslTypeId> 	operator+(const NslNumType,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator+(const float a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator+\n";
	cout << "// (NslNumType) " << a << " + (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a + b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator+(const double a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator+\n";
	cout << "// (NslNumType) " << a << " + (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a + b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator+(const int a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator+\n";
	cout << "// (NslNumType) " << a << " + (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a + b.get_data();
	return c;
}
// add_equal

template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out + a[i][j];
}
template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int amax = a.get_imax();

	out = 0;
	for (int i = 0; i < amax; i++)
		out = out + a[i];
}
template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>& out,const NslFloat0& a)
{
	out = a.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>& out,const NslDouble0& a)
{
	out = a.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_0<NslNumType,NslTypeId>& out,const NslInt0& a)
{
	out = a.get_data();
}

// add_plus

template<class NslNumType, int NslTypeId>
void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out + a[i][j];
}
template<class NslNumType, int NslTypeId>
void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out + a[i];
}
template<class NslNumType, int NslTypeId>
void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>& out,const NslFloat0& a)
{
	out.elem() += a.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>& out,const NslDouble0& a)
{
	out.elem() += a.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLadd_plus(nsl_num_0<NslNumType,NslTypeId>& out,const NslInt0& a)
{
	out.elem() += a.get_data();
}

// add_minus

template<class NslNumType, int NslTypeId>
void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out - a[i][j];
}
template<class NslNumType, int NslTypeId>
void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out - a[i];
}
template<class NslNumType, int NslTypeId>
void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>& out,const NslFloat0& a)
{
	out.elem() -= a.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>& out,const NslDouble0& a)
{
	out.elem() -= a.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLadd_minus(nsl_num_0<NslNumType,NslTypeId>& out,const NslInt0& a)
{
	out.elem() -= a.get_data();
}
