/* SCCS  @(#)nsl_matrix_prod_library.C	1.1---95/08/13--20:48:16 */
//
//	nsl_matrix_prod_library.C
//
/*
# include "nsl_all_kernel_include.h"

// product

nsl_data NSLprod(const nsl_vector& w,const nsl_vector& x)
{
	int size = w.get_imax();

	nsl_data c;

	if (size != x.get_imax())
	{
                cmd_error("*** NSLprod ***");
                cmd_error("Exit with the following status");
                w.print_status(cerr);
                x.print_status(cerr);
		cmd_error("Bad dimensions in NSLprod");
		return c;
	}
	
	for (int i = 0; i < size; i++)
		c = c + w[i]*x[i];

	return c;
}
nsl_vector NSLprod(const nsl_vector& w,const nsl_matrix& x)
{
	int size = x.get_imax();
	int vsize = x.get_jmax();

	nsl_vector c(vsize);

	if (size != w.get_imax())
	{
                cmd_error("*** NSLprod ***");
                cmd_error("Exit with the following status");
                w.print_status(cerr);
                x.print_status(cerr);
		cmd_error("Bad dimensions in NSLprod");
		return c;
	}
	
	for (int j = 0; j < vsize; j++)
	{
	    c[j] = 0;
	    for (int i = 0; i < size; i++)
		c[j] = c[j] + w[i]*x[i][j];
	}

	return c;
}
nsl_vector NSLprod(const nsl_matrix& w,const nsl_vector& x)
{
	int size = w.get_jmax();
	int vsize = w.get_imax();

	nsl_vector c(vsize);

	if (size != x.get_imax())
	{
                cmd_error("*** NSLprod ***");
                cmd_error("Exit with the following status");
                w.print_status(cerr);
                x.print_status(cerr);
		cmd_error("Bad dimensions in NSLprod");
		return c;
	}
		
	for (int i = 0; i < vsize; i++)
	{
	    c[i] = 0;
	    for (int j = 0; j < size; j++)
		c[i] = c[i] + w[i][j]*x[j];
	}

	return c;
}

nsl_matrix NSLprod(const nsl_matrix& w,const nsl_matrix& x)
{
	int isize = w.get_imax();
	int jsize = x.get_jmax();

	int size = w.get_jmax();

	nsl_matrix c(isize,jsize);

	if (size != x.get_imax())
	{
                cmd_error("*** NSLprod ***");
                cmd_error("Exit with the following status");
                w.print_status(cerr);
                x.print_status(cerr);
		cmd_error("Bad dimensions in NSLprod");
		return c;
	}
		
	for (int i = 0; i < isize; i++)
	    for (int j = 0; j < jsize; j++)
	    {
	    	c[i][j] = 0;
	    	for (int k = 0; k < size; k++)
		   c[i][j] = c[i][j] + w[i][k]*x[k][j];
	    }

	return c;
}
*/